config/routes.rb
# SPDX-FileCopyrightText: 2020 IN COMMON Collective <collective@incommon.cc>
# SPDX-License-Identifier: AGPL-3.0-or-later

Rails.application.routes.draw do

  get 'sections/show'
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html

  root to: 'welcome#index'

  # Agent routes
  resources :agents do
    shallow do
      # Classification routes
      resources :taxonomies do
        member do
          get :filter, to: 'taxonomies/filter#show'
        end
        resources :categories do
          resources :sections
        end
      end
      # Resource routes
      resources :resources
    end
  end

  # User routes
  get '/my/account', to: 'users#show', as: 'account'
  patch '/my/current_agent', to: 'my/agent#switch', as: 'agent_switch'
  get '/my/dashboard', to: 'welcome#dashboard'
  get '/my/peers', to: 'users#index', as: 'users'

  # UUID Resolver
  get '/by-uuid/:uuid', to: 'uuid_resolver#new', as: 'uuid_resolver'

  # Discourse SSO
  get 'authenticate(/:token)', to: 'welcome#authenticate', as: 'authenticate'
  get 'logout', to: 'welcome#logout'
end

app/controllers/application_controller.rb
# SPDX-FileCopyrightText: 2020 IN COMMON Collective <collective@incommon.cc>
#
# SPDX-License-Identifier: AGPL-3.0-or-later

class ApplicationController < ActionController::Base
  require 'sso'
  SSO::FromDiscourse.config = Rails.configuration.sso

  before_action :current_user

  protected

  include ApplicationHelper
  include AgentsHelper

  # Set current agent globally
  def current_agent
    @current_agent = Agent.find_by(name: current_agent_name)
  end
  helper_method :current_agent

  # Set current user globally
  def current_user
    @current_user ||= User.find_by(external_id: session[:current_user]) if session[:current_user].present?
  end
  helper_method :current_user

end

app/helpers/application_helper.rb
# SPDX-FileCopyrightText: 2020 IN COMMON Collective <collective@incommon.cc>
#
# SPDX-License-Identifier: AGPL-3.0-or-later

module ApplicationHelper
  # Set CSS classes on body tag
  def body_classes(*args)
    classes = args || []
    classes << controller_name
    classes << action_name
    ' class="'.html_safe << classes.join(' ') << '"'.html_safe
  end

  # Markdown helper
  # Always use all extensions. Additional parser and render options may be
  # passed as a second argument.
  #
  # @param markdown (String) a string to parse as Markdown source
  # @param options (String or Array) an optional parser/renderer option
  # @return String HTML-formatted from Mardkown source
  def m(markdown, options = nil)
    tag.div(
      CommonMarker.render_doc(
        markdown.to_s,
        options.to_a + default_commonmarker_options,
        default_commonmarker_extensions
      ).to_html.html_safe, class: 'markdown')
  end

  # Link to current application version
  def version_link
    version = begin
                IO.read('.app-version')&.strip
              rescue
                'HEAD'
              end

    link_to(version, INCOMMON.repo_url(version), title: 'Read source code')
  end

  private

  # CommonMarker extensions
  # See https://github.com/gjtorikian/commonmarker#extensions
  def default_commonmarker_extensions
    [
      :table,
      :tasklist,
      :strikethrough,
      :autolink,
      :tagfilter
    ]
  end

  # CommonMarker options
  # See https://github.com/gjtorikian/commonmarker#options
  def default_commonmarker_options
    [
      #:HARDBREAKS, # only seems to work with render_html, but then all others
                    # only work with render_doc
      :FOOTNOTES,
      :SMART,
      :STRIKETHROUGH_DOUBLE_TILDE,
      :VALIDATE_UTF8
    ]
  end
end

app/views/application/_current_agent_link.html.erb
<%= render partial: 'current_agent_switch' %>

app/views/application/_current_agent_switch.html.erb
<%= form_for current_agent, url: '/my/current_agent', method: :patch do |f| %>
    <%= f.select(:id, options_for_select(current_user.agents.map { |a| [a.name, a.id] }, selected: current_agent.id), title: "Sélectionner l'agent en cours") %>
    <%= f.submit(" » ", title: "Activer cet Agent") %>
<% end %>

app/views/application/_debug.html.erb
<% if Rails.env.development? && current_user.present? %>
    <div id="debug">
        <%= yield :debug %>
    </div>
<% end %>

app/views/application/_flash.html.erb
<div id="flashes"><% flash.each do |type, msg| %>
    <span class="<%= type %>"><%= msg %></span>
<% end %></div>

app/views/application/_taxonomy_nav.html.erb
<% out = []
clazo.each do |c| %>
    <%= tag.span(taxo.name) %>  »
    <%= link_to(c.section.category.name, c.section.category) %>  »
    <%= link_to(c.section.name, c.section) %> »
<% end %>

app/views/application/_user_info.html.erb
<section id="user_info" class="<%= current_user.present? ? 'authenticated' : 'anonymous' %>">
    <nav>
        <% if current_user.present? %>
        <a href="/my/dashboard"><%= image_tag current_user.avatar_url, alt: current_user.username %></a>
        <ul>
            <%= tag.li link_to("Ajouter un point", new_agent_resource_url(agent_id: current_agent)) %>
            <%= tag.li link_to("Terminer la session", logout_url) %>
        </ul>
        <% else %>
        <%= link_to image_tag('login.png', alt: 'Se connecter'), '/authenticate' %>
        <% end %>
    </nav>
</section>

<% content_for :debug do %>
<%= @current_user&.avatar_url %>
<% end %>

app/views/application/_version.html.erb
<div class="app-version" title="This is free software: you can access and acquire the source code">
    version <span><%= version_link %></span>
</div>